.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgw::seditor 0.3" "" "" "" ""
.hy
.SS NAME
.PP
\f[B]dgw::seditor\f[R] \- extended Tk text editor widget with toolbar
buttons, configurable syntax highlighting, window splitting facilities
and right click popupmenu for standard operations like cut, paste etc.
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
WIDGET OPTIONS
.IP \[bu] 2
WIDGET COMMANDS
.IP \[bu] 2
KEY BINDINGS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DEMO
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
CHANGES
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHORS
.IP \[bu] 2
COPYRIGHT
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require Tk
package require snit
package require dgw::seditor
dgw::seditor pathName ?options?
pathName configure option value
pathName cget option
pathName loadFile filename ?boolean?
\f[R]
.fi
.SS DESCRIPTION
.PP
The widget \f[B]dgw::seditor\f[R] inherits from the standard Tk text
editor widget all methods and options but has further a standard
toolbar, a right click context menu and allows easy configuration for
syntax highlighting.
Scrollbars are as well added by default, they are only shown however if
necessary.
Furthermore window splitting is added, the user can split the text
editor window into two by pressing and thereafter either 2 or 3,
splitting can be undone by pressing and thereafter the key 1.
.SS COMMAND
.PP
\f[B]dgw::seditor\f[R] \f[I]pathName ?\-option value \&...?\f[R]
.RS
.PP
Creates and configures the \f[B]dgw::seditor\f[R] widget using the Tk
window id \f[I]pathName\f[R] and the given \f[I]options\f[R].
.RE
.SS WIDGET OPTIONS
.PP
As the \f[B]dgw::seditor\f[R] is an extension of the standard Tk text
editor widget it supports all method and options of the tk text editor
widget.
The following options are added by the \f[I]dgw::seditor\f[R] widget:
.SH file seditor.ini
.PP
[Python] extension=\f[I].py \f[R].pyw package=^(import|from).+
string=[\[dq]\[cq]].+?[\[dq]\[cq]] method=^(def|class)+[A\-Z0\-9_a\-z]+
keyword=(\[ha]| )(self|False|True|for|if|elif|else|try|and|as)
comment=#.+ \f[B]\-accelerator\f[R] \f[I]keysequence\f[R]
.RS
.PP
The key shortcut to execute a possibly given \f[I]\-toolcommand\f[R].
Defaults to or .
Does nothing if no \f[I]\-toolcommand\f[R] is given.
.RE
.PP
\f[B]\-filetypes\f[R] \f[I]list of filetypes\f[R]
.RS
.PP
The filetypes to be used for the file dialogs if the open or save
buttons are pressed.
Defaults to Text (*.txt), SQL (*.sql) and all files (*.*).
See the Example section on how to define other additional file
extensions.
.RE
.PP
\f[B]\-font\f[R] \f[I]fontname\f[R]
.RS
.PP
The font to be used for the text widget.
Defaults to Tk standards which are depending on the platform.
.RE
.PP
\f[B]\-hilightcommand\f[R] \f[I]command\f[R]
.RS
.PP
The command to be used for highlighting.
The user can with this supply their own commands to do syntax
highlighting.
Please note, that the widget path of the text widget is appended to the
argument list.
.RE
.PP
\f[B]\-hilights\f[R] \f[I]list\f[R]
.RS
.PP
The list to be used for syntax highlighting the widget.
It is a nested list where the first element is the file extension
without the dot, the second element is the tagname and the third is the
regular expression used for highlighting.
Valid tagnames are: header, comment, highlight, keyword, string,
package, class, method, proc.
With the usual command
\f[C]pathName tag configure tagname \-forground color\f[R] etc., the
developer can overwrite the default tag settings.
.RE
.PP
\f[B]\-inifiles\f[R] \f[I]list\f[R]
.RS
.PP
The list of ini files to be used for hilights.
The ini files are loaded if this option is configured.
Per default the file \f[I]seditor.ini\f[R] in the same directory as
seditor.tcl and a file seditor.ini in the folder
\f[C].config/dgw/seditor.ini\f[R] in the users home directory are loaded
autmoatically if they exist.
See the following example for an editor widget which provides Python
highlighting\-
.RE
.RS
.IP
.nf
\f[C]
\f[R]
.fi
.RE
.PP
\f[B]\-lineaccelerator\f[R] \f[I]keysequence\f[R]
.RS
.PP
The key shortcut to execute a possibly given \f[I]\-toolcommand\f[R]
with the current line as input.
Defaults to .
Does nothing if no \f[I]\-toolcommand\f[R] is given.
.RE
.PP
\f[B]\-selectionaccelerator\f[R] \f[I]keysequence\f[R]
.RS
.PP
The key shortcut to execute a possibly given \f[I]\-toolcommand\f[R].
with the current selection text as input.
Defaults to .
Does nothing if no \f[I]\-toolcommand\f[R] is given.
.RE
.PP
\f[B]\-toolcommand\f[R] \f[I]command\f[R]
.RS
.PP
The text inside the text area can be executed with the give
\f[I]\-toolcommand\f[R].
For instance you can execute a SQL statement which was written into the
text editor against a database.
There is also the possibility to execute just the current line, or the
current selection.
See the options for setting accelerators keys.
Please note, that the text, either the current selection, the current
line or the complete widget text is appended to the command as first
argument.
Defaults to empty string, so no toolcommand is executable on the current
text.
.RE
.PP
\f[B]\-toollabel\f[R] \f[I]string\f[R]
.RS
.PP
Label to be used as the Tool label in the popupmenu and if the tool
Button on the top right is hovered with the mouse.
Defaults to \[lq]tool\[rq]
.RE
.SS WIDGET COMMANDS
.PP
Each \f[B]dgw::seditor\f[R] widget supports all usual methods of the Tk
text widget and it adds the follwing method(s):
.PP
\f[I]pathName\f[R] \f[B]doHilights\f[R] \f[I]?mode?\f[R]
.RS
.PP
Hilights the text within in the editor in the language given with the
mode variable.
The following arguments are supported:
.RE
.RS
.PP
\f[I]mode\f[R] \- the programming or markup language used for
hilighting, the following modes are already embedded into the widget:
\f[I]tcl\[cq] (default), \f[R]sql\[cq], \f[I]text\[cq]. Other modes can
be added to the widget by specifying the option \f[R]\-hilights* or by
using the inifile.
.RE
.PP
\f[I]pathName\f[R] \f[B]loadFile\f[R] \f[I]filename
?reload:boolean?\f[R]
.RS
.PP
Loads the given filename into the text widget or reloads the currently
loaded file if reload is set to true.
The default for reload is false.
\f[I]pathName\f[R] \f[B]fileNew\f[R]
.RE
.RS
.PP
Loads a empty new file into the editor widget, if the previous file in
the widget was changed and not saved, before opening a new file, a
dialogbox will show up, asking the user if he would like to save the
file.
.RE
.SS KEY BINDINGS
.PP
In addition to the standard Bindings of a text editor widget the
\f[I]dgw::editor\f[R] provides the following key and mouse bindings.
.IP \[bu] 2
\f[C]mouse right click\f[R] : editor popup with cut, paste etc.
.IP \[bu] 2
\f[C]Ctrl\-x 2\f[R]: split the window vertically
.IP \[bu] 2
\f[C]Ctrl\-x 3\f[R]: split the window horizontally
.IP \[bu] 2
\f[C]Ctrl\-x 1\f[R] undo the splitting
.IP \[bu] 2
\f[C]Shift\-Return\f[R]: Send the widget text to toolcommand
.IP \[bu] 2
\f[C]Control\-Return\f[R]: send the ehe current line to toolcommand
.IP \[bu] 2
\f[C]Control\-Shift\-Return\f[R]: send the current selection to
toolcommand
.PP
Please note, that the toolcommand accelerator keys can be changed to
other keys by using the options of this widget.
.SS EXAMPLE
.PP
In the example below we create a Markdown markup aware text editor.
.IP
.nf
\f[C]
package require dgw::seditor
dgw::seditor .top \-hilights {{md header \[ha]#.+}    
                             {md comment \[ha]>.+} 
                             {md keyword _{1,2}[\[ha]_]+_{1,2}}  
                             {md string {\[dq][\[ha]\[dq]]+\[dq]}}}
pack .top \-side top \-fill both \-expand true ;#\[dq]  
\&.top configure \-filetypes {{Markdown Files}  {.md}}

# create a sample Markdown file and load it later
set out [open test.md w 0600] 
puts $out \[dq]# Header example\[rs]n\[dq]
puts $out \[dq]_keyword_ example\[rs]n\[dq]
puts $out \[dq]Some not hilighted text\[rs]n\[dq]
puts $out \[dq]> some markdown quote text\[rs]n\[dq]
puts $out \[dq]## Subheader\[rs]n\[dq]
puts $out \[dq]Some more standard text with two \[rs]\[dq]strings\[rs]\[dq] which are \[rs]\[dq]inside!\[rs]\[dq]\[dq] 
puts $out [lsort [.top cget \-filetypes]]
close $out
\&.top loadFile test.md
\f[R]
.fi
.SS INSTALLATION
.PP
Installation is easy you can install and use the \f[B]dgw::seditor\f[R]
package if you have a working install of:
.IP \[bu] 2
the snit package which can be found in tcllib \-
https://core.tcl\-lang.org/tcllib (https://core.tcl-lang.org/tcllib)
.PP
For installation you copy the complete \f[I]dgw\f[R] folder into a path
of your \f[I]auto_path\f[R] list of Tcl or you append the
\f[I]auto_path\f[R] list with the parent dir of the \f[I]dgw\f[R]
directory.
Alternatively you can install the package as a Tcl module by creating a
file dgw/seditor\-0.3.tm in your Tcl module path.
The latter in many cases can be achieved by using the
\f[I]\[en]install\f[R] option of seditor.tcl.
Try \[lq]tclsh seditor.tcl \[en]install\[rq] for this purpose.
.SS DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ wish seditor.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ tclsh seditor.tcl \-\-code
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh seditor.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag.
.IP
.nf
\f[C]
$ tclsh seditor.tcl \-\-html
\f[R]
.fi
.PP
If the tcllib Markdown package is installed, this will directly create a
HTML page \f[C]seditor.html\f[R] which contains the formatted
documentation.
.PP
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.IP
.nf
\f[C]
$ tclsh seditor.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to feed a Markdown processor for
conversion into a html, docx or pdf document.
If you have pandoc installed for instance, you could execute the
following commands:
.IP
.nf
\f[C]
tclsh ../seditor.tcl \-\-man > seditor.md
pandoc \-i seditor.md \-s \-o seditor.html
pandoc \-i seditor.md \-s \-o seditor.tex
pdflatex seditor.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
dgw package
homepage (https://chiselapp.com/user/dgroth/repository/tclcode/index) \-
various useful widgets
.IP \[bu] 2
ctext widget in tklib (https://wiki.tcl-lang.org/page/Tklib+Contents)
other syntax hilighting widget
.IP \[bu] 2
text widget manual (https://www.tcl.tk/man/tcl8.6/TkCmd/text.htm)
standard manual page for the underlying text widget
.SS CHANGES
.IP \[bu] 2
2020\-02\-04 \- version 0.3 started
.IP \[bu] 2
adding splitting window keys and word wrap button to the toolbar
.IP \[bu] 2
fixing splitting issues, updating documentation
.IP \[bu] 2
automatic loading of infile from /.config/dgw/seditor.ini added
.SS TODO
.IP \[bu] 2
config file for syntax hilights in the same directory as the source code
and in some config dir in the home directory
.IP \[bu] 2
example for a derived syntax editor with an added syntax hilight schema
.IP \[bu] 2
more, real, tests
.IP \[bu] 2
github url for putting the code
.SS AUTHORS
.PP
The \f[B]dgw::seditor\f[R] widget was written by Detlef Groth,
Schwielowsee, Germany.
.SS Copyright
.PP
Copyright (c) 2019\-20 Dr.\ Detlef Groth, E\-mail:
detlef(at)dgroth(dot)de
.SS LICENSE
.PP
dgw::seditor package, version 0.3.
.PP
Copyright (c) 2019\-2020 Dr.\ Detlef Groth, E\-mail:
detlef(at)dgroth(dot)de
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
