.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgw::sqlview 0.6" "" "" "" ""
.hy
.SS NAME
.PP
\f[B]dgw::sqlview\f[R] \- database browser widget and standalone
application
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
METHODS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
MARKUP LANGUAGE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
CHANGES
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHOR
.IP \[bu] 2
LICENSE AND COPYRIGHT
.SS SYNOPSIS
.PP
Usage as package:
.IP
.nf
\f[C]
package require Tk
package require snit
package require tdbc::sqlite3 
package require dgw::seditor 
package require dgw::hyperhelp
package require dgw::basegui
package require dgw::sqlview
dgw::sqlview pathName \-database filename ?\-funcfile sqlfunc.tcl?
dgw::sqlview tedit insert \[dq]sql statement\[dq]
dgw::sqlview tedit doHilights sql
\f[R]
.fi
.PP
Usage as command line application:
.IP
.nf
\f[C]
tclsh sqlview.tcl databasename
\f[R]
.fi
.SS DESCRIPTION
.PP
The \f[B]dgw::sqlview\f[R] package provides a SQL database browser
widget as well as a standalone application.
It main parts a treeview database structure viewer, a text editor with
SQL syntax hilighting, and a tableview widget for viewing the results of
the entered SQL statements.
The editor widget provides shortcuts to execute either the current
selection, the current line or the complete text entered in the text
widget.
.SS COMMAND
.PP
\f[B]dgw::sqlview\f[R] \f[I]pathName \-database fileName ?\-option value
\&...?\f[R]
.RS
.PP
creates a new \f[I]sqlview\f[R] widget using the given widget
\f[I]pathName\f[R] and with the given \f[I]\-database fileName\f[R].
Please note, that the filename must be currently a sqlite3 database.
Support for other database types can be added on request.
.RE
.SS OPTIONS
.PP
The \f[I]dgw::sqlview\f[R] snit widget supports the following options:
.PP
\f[B]\-database\f[R] \f[I]filename\f[R]
.RS
.PP
Configures the database used within the widget.
Should be set already at widget initialization.
.RE
.PP
\f[B]\-funcfile\f[R] \f[I]filename(s)\f[R]
.RS
.PP
Load SQL functions from the file given with the \f[I]\-funcfile\f[R]
option.
Please note, that all SQL functions written in Tcl must be created
within the \f[I]sqlfunc\f[R] namespace.
If the \f[I]filenames\f[R] are a list, every file of this list will be
loaded.
See the following example for the beginning of such a
\f[C]funcfile.tcl\f[R]:
.RE
.RS
.IP
.nf
\f[C]
namespace eval ::sqlfunc {}
# replace all A\[aq]s with B\[aq]s
proc ::sqlfunc::mmap args {
return [string map {A B} [lindex $args 0]]
}
# support for regexp: rgx(\[aq]\[ha]AB\[aq],colname)
proc ::sqlfunc::rgx {args} {
return [regexp [lindex $args 0] [lindex $args 1]]
}
# support for replacements: rsub(\[aq]\[ha]AB\[aq],colname,\[aq]\[aq])
proc ::sqlfunc::rsub {args} {
return [regsub [lindex $args 0] [lindex $args 1] [lindex $args 2]]
}
\f[R]
.fi
.RE
.PP
\f[B]\-log\f[R] \f[I]boolean\f[R]
.RS
.PP
Should all executed statements written into the logfile.
Default true.
.RE
.PP
\f[B]\-logfile\f[R] \f[I]filename\f[R]
.RS
.PP
The file where all executed statements of the sqlview editor widget are
written into.
If not given, defaults to an the file sqlview.log in the users home
directory.
.RE
.PP
\f[B]\-type\f[R] \f[I]sqlite3\f[R]
.RS
.PP
Configures the database type, currently only the type sqlite3 is
supported.
Other types can be added on request.
Should be set only at widget initialisation.
.RE
.SS METHODS
.PP
The \f[I]dgw::sqlview\f[R] widget provides the following methods:
.PP
\f[I]pathName\f[R] \f[B]changeFontSize\f[R] \f[I]integer\f[R]
.RS
.PP
Increase (positive integer values) or decrease widget (negative integer
values) font size of all text and ttk::treeview widgets.
.RE
.PP
\f[I]pathName\f[R] \f[B]closeSQLview\f[R]
.RS
.PP
Destroys the sqlview widget.
A message box will be shown to verify that the widget should be really
destroyed.
This as well disconnects the database cleanly.
.RE
.PP
\f[I]pathName\f[R] \f[B]dbConnect\f[R]
.RS
.PP
Connect to the actual database.
Currently only SQLite 3 is supported.
.RE
.PP
\f[I]pathName\f[R] \f[B]dbDisconnect\f[R]
.RS
.PP
Disconnect the actual database.
Currently only SQLite 3 is supported.
.RE
.PP
\f[I]pathName\f[R] \f[B]dbSelect\f[R] \f[I]statement\f[R]
.RS
.PP
Execute the given statement against the database and insert the result
into the tableview widget at the bottom.
.RE
.PP
\f[I]pathName\f[R] \f[B]executeSQL\f[R] \f[I]mode\f[R]
.RS
.PP
Execute a SQL statement against the current database.
If mode is `all' (default) the complete text entered in the text editor
widget will be used as statement.
The \f[I]mode\f[R] can be as well `line' where only the current line is
executed, or `selection' where only the currently selected text is send
to the database.
.RE
.PP
\f[I]pathName\f[R] \f[B]getDBVersion\f[R]
.RS
.PP
Returns the SQLite 3 version of the current database implementation.
.RE
.PP
\f[I]pathName\f[R] \f[B]openDatabase\f[R] \f[I]?filename?\f[R]
.RS
.PP
Open the database using the given \f[I]filename\f[R] is given.
If not \f[I]filename\f[R] is given opens the open file dialog.
.RE
.PP
\f[I]pathName\f[R] \f[B]refreshDatabase\f[R]
.RS
.PP
Refresh the treeview widget which shows the database structure.
Useful if the database was updated.
.RE
.PP
\f[I]pathName\f[R] \f[B]showHistory\f[R] \f[I]toplevel\f[R]
.RS
.PP
Displays the SQL statement history in the given toplevel path.
Default: \f[C].history\f[R]
.RE
.PP
\f[I]pathName\f[R] \f[B]tedit\f[R] \f[I]arguments\f[R]
.RS
.PP
Expose the interface of the \f[I]dgw::seditor\f[R] text widget, so you
can use all of its methods and the methods of the standard text editor
widget.
For example:
.RE
.RS
.PP
\f[C]pathName tedit insert end \[dq]select * from students\[dq]\f[R]
.RE
.SS KEY BINDINGS
.SS Editor widget
.PP
In addition to the standard bindings of the Tk text editor widget, the
SQL editor widget, \f[I]dgw::seditor\f[R], in the upper right, provides
the following key and mouse bindings:
.IP \[bu] 2
\f[C]mouse right click\f[R] : editor popup with cut, paste etc.
.IP \[bu] 2
\f[C]Ctrl\-x 2\f[R]: split the window vertically
.IP \[bu] 2
\f[C]Ctrl\-x 3\f[R]: split the window horizontally
.IP \[bu] 2
\f[C]Ctrl\-x 1\f[R] undo the splitting
.IP \[bu] 2
\f[C]Shift\-Return\f[R]: Send the widget text to the configured
\f[I]\-toolcommand\f[R]
.IP \[bu] 2
\f[C]Control\-Return\f[R]: send the current line to configured
\f[I]\-toolcommand\f[R]
.IP \[bu] 2
\f[C]Control\-Shift\-Return\f[R]: send the current selection to the tool
command
.PP
Please note, that the tool command accelerator keys can be changed to
other keys by using the options of the \f[I]dgw::seditor\f[R] widget
using the \f[C]tedit\f[R] sub command of the \f[I]dgw::sqlview\f[R]
widget.
.SS Tableview widget
.PP
The tableview widget at the bottom can be sorted by column if the user
clicks on the column headers.
It otherwise provides the standard bindings of the ttk::treeview widget
to the developer and user.
.SS Notebook tabs
.PP
The following shortcuts are only available if the users click on the
notebook tab:
.IP \[bu] 2
Ctrl\-Tab: after click on the notebook will open a new tab, Ctrl\-Tab
outside of the notebook widget will change the visible tab
.IP \[bu] 2
Ctrl\-Shift\-Left: Move tab to the left.
.IP \[bu] 2
Ctrl\-Shift\-Right: move tab to the right
.IP \[bu] 2
Ctrl\-w: closes the tab if the users confirms the dialog box message.
.IP \[bu] 2
Right mouse click: change the tab name.
.PP
If you the notebook tab has not the focus you have the following
bindings available:
.IP \[bu] 2
Ctrl\-Tab: cycle the tabs and bring the next in the forground, also
called tab traversal.
.SS EXAMPLE
.PP
In the example below we create a sample database and load the database
and their information into the three sub widgets.
.IP
.nf
\f[C]
package require dgw::sqlview
set sqlv [::dgw::sqlview .sql \-database test.sqlite3 \-funcfile sqlfunc.tcl]
# create a test database
$sqlv dbSelect \[dq]drop table if exists students\[dq]
$sqlv dbSelect \[dq]create table students (id INTEGER, firstname TEXT, lastname TEXT, city TEXT)\[dq]
$sqlv dbSelect \[dq]insert into students (id,firstname, lastname, city) values (1234, \[aq]Marc\[aq], \[aq]Musterman\[aq], \[aq]Mustercity\[aq])\[dq]
$sqlv dbSelect \[dq]insert into students (id,firstname, lastname, city) values (1235, \[aq]Marcella\[aq], \[aq]Musterwoman\[aq], \[aq]Berlin\[aq])\[dq]
$sqlv refreshDatabase
$sqlv tedit doHilights sql
$sqlv tedit insert end \[dq] select * from students\[dq]
$sqlv executeSQL
pack $sqlv \-side top \-fill both \-expand yes
\f[R]
.fi
.SS INSTALLATION
.PP
You can install and use the \f[B]dgw::sqlview\f[R] package if you have a
working install of:
.IP \[bu] 2
Tcl/Tk installed together with the database extensions \f[I]tdbc\f[R]
.IP \[bu] 2
the snit package, which is part of
tcllib (https://core.tcl-lang.org/tcllib)
.PP
If you have this, then download the latest \f[I]dgw\f[R] and
\f[I]dgtools\f[R] package releases from: dgw package release
page (https://chiselapp.com/user/dgroth/repository/tclcode/wiki?name=releases).
For installation unzip the latest \f[I]dgw\f[R] and \f[I]dgtools\f[R]
zip files and copy the complete \f[I]dgw\f[R] and \f[I]dgtools\f[R]
folders into a path of your \f[I]auto_path\f[R] list of Tcl.
Alternatively you can append the \f[I]auto_path\f[R] list with the
parent directory of the \f[I]dgw\f[R] directory.
.SS DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ wish sqlview.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ tclsh sqlview.tcl \-\-code
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh sqlview.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag.
.IP
.nf
\f[C]
$ tclsh sqlview.tcl \-\-html
\f[R]
.fi
.PP
If the tcllib Markdown package is installed, this will directly create a
HTML page \f[C]sqlview.html\f[R] which contains the formatted
documentation.
.PP
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.IP
.nf
\f[C]
$ tclsh sqlview.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to feed a Markdown processor for
conversion into a html, docx or pdf document.
If you have pandoc installed for instance, you could execute the
following commands:
.IP
.nf
\f[C]
tclsh ../sqlview.tcl \-\-man > sqlview.md
pandoc \-i sqlview.md \-s \-o sqlview.html
pandoc \-i sqlview.md \-s \-o sqlview.tex
pdflatex sqlview.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
dgw package
homepage (https://chiselapp.com/user/dgroth/repository/tclcode/index) \-
various other useful widgets and tools to build Tcl/Tk applications.
.SS CHANGES
.IP \[bu] 2
2020\-03\-05 \- version 0.6 started
.SS TODO
.IP \[bu] 2
tests
.IP \[bu] 2
github url
.SS AUTHORS
.PP
The \f[B]dgw::sqlview\f[R] widget was written by Detlef Groth,
Schwielowsee, Germany.
.SS Copyright
.PP
Copyright (c) 2019\-20 Dr.\ Detlef Groth, E\-mail:
detlef(at)dgroth(dot)de
.SS LICENSE
.PP
dgw::sqlview package, version 0.6.
.PP
Copyright (c) 2019\-2020 Dr.\ Detlef Groth, E\-mail:
detlef(at)dgroth(dot)de
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Dr.\ Detlef Groth, Schwielowsee, Germany.
