.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgw::tablelist 0.2" "" "2019\-11\-04" "" ""
.hy
.SS NAME
.PP
\f[B]dgw::tablelist\f[R] \- extended tablelist widget with icons and
tree mode implementation.
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
WIDGET OPTIONS
.IP \[bu] 2
WIDGET COMMANDS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DEMO
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
SEE also
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHORS
.IP \[bu] 2
COPYRIGHT
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require Tk
package require snit
package require dgw::tablelist
dgw::tablelist pathName ?options?
pathName configure \-option value
pathName cget \-option 
pathName loadFile filename ?boolean?
\f[R]
.fi
.SS DESCRIPTION
.PP
The widget \f[B]dgw::tablelist\f[R] inherits from the standard tablelist
widget all methods and options but has embedded standard icons.
The treemode of tablelist is supported further with changing icons on
opening and closing tree nodes.
.SS COMMAND
.PP
\f[B]dgw::tablelist\f[R] \f[I]pathName ?options?\f[R]
.RS
.PP
Creates and configures the \f[B]dgw::tablelist\f[R] widget using the Tk
window id \f[I]pathName\f[R] and the given \f[I]options\f[R].
.RE
.SS WIDGET OPTIONS
.PP
As the \f[B]dgw::tablelist\f[R] is an extension of the tablelist widget
it has all the options of the tablelist widget.
The following options are added or modified:
.PP
\f[B]\-browsecmd\f[R] \f[I]script\f[R]
.RS
.PP
Set a command if the user double clicks an entry in the listbox or
presses the \f[C]Return\f[R] key if the widget has the focus.
The widget path and the index of the item getting the event are appended
to the script call as function arguments.
So the implementation of the script should have two arguments in the
parameter list as shown in the following example:
.RE
.RS
.IP
.nf
\f[C]
proc click {tbl idx} {
puts [$tbl itemcget $idx \-text]
}
dgw::tablelist .tl \-browsecmd click
\f[R]
.fi
.RE
.PP
\f[B]\-collapsecommand\f[R] \f[I]command\f[R]
.RS
.PP
This options is per default configured to change the icons in the tree
for parent items which have child items if the node is opened.
Can be overwritten by the user.
.RE
.PP
\f[B]\-collapseicon\f[R] \f[I]iconprefix\f[R]
.RS
.PP
The imagw which should be displayed if a folder node is closed.
Currently the default is a folder icon.
.RE
.PP
\f[B]\-expandcommand\f[R] \f[I]command\f[R]
.RS
.PP
This options is per default configured to change the icons in the tree
for parent items which have child items.
Can be overwritten by the user.
.RE
.PP
\f[B]\-treestyle\f[R] \f[I]stylename\f[R]
.RS
.PP
Currently this option is just delegated to the standard tablelist
widget.
.RE
.SS WIDGET COMMANDS
.PP
Each \f[B]dgw::tablelist\f[R] widget supports all the commands of the
standard tablelist widget.
See the tablelist manual page for a description of those widget
commands.
.SS EXAMPLE
.IP
.nf
\f[C]
proc click {tbl idx} {
     puts \[dq]clicked in $tbl on $idx\[dq]
}
dgw::tablelist .mtab   \-columns {0 \[dq]Name\[dq]  left 0 \[dq]Page\[dq] left} \[rs]
       \-movablecolumns no \-setgrid no \-treecolumn 0 \-treestyle gtk \-showlabels false \[rs]
       \-stripebackground white \-width 40 \-height 25 \[rs]
       \-browsecmd click

 pack .mtab \-side left \-fill both \-expand yes
 dgw::tablelist .mtab2   \-columns {0 \[dq]Name\[dq]  left 0 \[dq]Page\[dq] left} \[rs]
       \-movablecolumns no \-setgrid no \-treecolumn 0 \-treestyle ubuntu \-showlabels false \[rs]
       \-stripebackground grey90 \-width 40 \-height 25

 pack .mtab2 \-side left \-fill both \-expand yes
 set x 0 
 while {[incr x] < 5} {
     set y 0
     set parent [.mtab insertchild root end [list Name$x $x]]
     set parent [.mtab2 insertchild root end [list Name$x $x]]        
     while {[incr y] < 5} {
         .mtab insertchild $parent end [list Child$y $y]
         .mtab2 insertchild $parent end [list Child$y $y]
     }
 }
\f[R]
.fi
.SS INSTALLATION
.PP
Installation is easy you can install and use the
\f[B]dgw::tablelist\f[R] package if you have a working install of:
.IP \[bu] 2
the snit package which can be found in tcllib \-
https://core.tcl\-lang.org/tcllib (https://core.tcl-lang.org/tcllib)
.PP
For installation you copy the complete \f[I]dgw\f[R] folder into a path
of your \f[I]auto_path\f[R] list of Tcl or you append the
\f[I]auto_path\f[R] list with the parent dir of the \f[I]dgw\f[R]
directory.
Alternatively you can install the package as a Tcl module by creating a
file dgw/tablelist\-0.2.tm in your Tcl module path.
The latter in many cases can be achieved by using the
\f[I]\[en]install\f[R] option of tablelist.tcl.
Try \[lq]tclsh tablelist.tcl \[en]install\[rq] for this purpose.
.SS DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ wish tablelist.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ wish tablelist.tcl \-\-code
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh tablelist.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag.
.IP
.nf
\f[C]
$ tclsh tablelist.tcl \-\-html
\f[R]
.fi
.PP
This will directly create a HTML page \f[C]tablelist.html\f[R] which
contains the formatted documentation.
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.IP
.nf
\f[C]
$ tclsh tablelist.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to feed a markdown processor for
conversion into a man page, html or pdf document.
If you have pandoc installed for instance, you could execute the
following commands:
.IP
.nf
\f[C]
# man page
tclsh tablelist.tcl \-\-man | pandoc \-s \-f markdown \-t man \- > tablelist.n
# html 
tclsh tablelist.tcl \-\-man > tablelist.md
pandoc \-i tablelist.md \-s \-o tablelist.html
# pdf
pandoc \-i tablelist.md \-s \-o tablelist.tex
pdflatex tablelist.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
dgw \- package homepage:
http://chiselapp.com/user/dgroth/repository/tclcode/index (http://chiselapp.com/user/dgroth/repository/tclcode/index)
.SS TODO
.IP \[bu] 2
more icons
.IP \[bu] 2
more, real, tests
.IP \[bu] 2
github url for putting the code
.SS AUTHOR
.PP
The dgw::\f[B]tablelist\f[R] widget was written by Detlef Groth,
Schwielowsee, Germany.
.SS LICENSE
.PP
dgw::tablelist widget dgw::tablelist, version 0.2.
.PP
Copyright (c)
.IP \[bu] 2
2019\-2020 Dr.\ Detlef Groth, <detlef (at) dgroth(dot)de>
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
